//Part of this source code is based on the grider 3.3.1 msi remote plugin
//availible here : http://sweb.cz/j.tuma/
//i have no idea who made it, there's no name specified anywhere on that site
//but thanks a lot !!!
unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ComCtrls,tlhelp32;

type
  TIRCommand = record
    IRCode : integer;
    Action : integer;
    target : string[255];
    Key : integer;
  end;

  TFrmIrMonitor = class(TForm)
    log: TMemo;
    Timer: TTimer;
    ButAddCommand: TButton;
    ListView: TListView;
    ButEditCommand: TButton;
    ButDeleteCommand: TButton;
    ButExport: TButton;
    ButImport: TButton;
    SaveDialog: TSaveDialog;
    OpenDialog: TOpenDialog;
    ButClearAll: TButton;
    procedure TimerTimer(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure ButAddCommandClick(Sender: TObject);
    procedure ListViewData(Sender: TObject; Item: TListItem);
    procedure ButEditCommandClick(Sender: TObject);
    procedure ButDeleteCommandClick(Sender: TObject);
    procedure ButExportClick(Sender: TObject);
    procedure ButImportClick(Sender: TObject);
    procedure ButClearAllClick(Sender: TObject);
  private
    { Private declarations }
    IRCommands : Array[0..254] of TIRCommand;
  public
    { Public declarations }
    NumberOfIRCommands : Integer;
    InitRemoteCtrl: function (hWndApp:HWND):BOOL;
    ReadRemoteData: function : DWORD;
    function StartMSI:boolean;
    function StopMSI:boolean;
    procedure Error(const msg:string);
    procedure HandleIR(Key: DWORD);
    procedure Sendkey(Key: char);
    procedure SendAltkey(key : char);
    function ProcessRunning(exefile : string): boolean;
    procedure ErasePreviousCommand();
    procedure SaveSettings(filename: string);
    procedure LoadSettings(filename: string);
    procedure ClearIRCommands();
  end;

var
  FrmIrMonitor: TFrmIrMonitor;
  started: boolean = False;
  lib: THandle;

implementation

uses unit2,shellapi,inifiles;
{$R *.dfm}


procedure TFrmIrMonitor.SaveSettings(filename: string);
var
 ini : Tinifile;
 teller : integer;
begin
 ini := Tinifile.Create(filename);
 ini.WriteInteger('Main','NrOfIrCommands',NumberOfIRCommands);
 for teller := 0 to NumberOfIRCommands-1 do
 begin
  ini.Writeinteger('Command' + inttostr(teller),'Ir Code',IrCommands[teller].IRCode);
  ini.Writeinteger('Command' + inttostr(teller),'Action',IrCommands[teller].Action);
  ini.WriteString('Command' + inttostr(teller),'Target',IrCommands[teller].Target);
  ini.Writeinteger('Command' + inttostr(teller),'Keyboard Key',IrCommands[teller].key);
 end;
 ini.Free;
end;

procedure TFrmIrMonitor.LoadSettings(filename: string);
var
 ini : Tinifile;
 teller : integer;
begin
 ClearIRCommands();
 ini := Tinifile.Create(filename);
 NumberOfIRCommands := ini.ReadInteger('Main','NrOfIrCommands',0);
 for teller := 0 to NumberOfIRCommands-1 do
 begin
  IrCommands[teller].IRCode := ini.Readinteger('Command' + inttostr(teller),'Ir Code',-1);
  IrCommands[teller].Action := ini.Readinteger('Command' + inttostr(teller),'Action',-1);
  IrCommands[teller].Target := ini.ReadString('Command' + inttostr(teller),'Target','');
  IrCommands[teller].key :=  ini.Readinteger('Command' + inttostr(teller),'Keyboard Key',-1);
 end;
 ini.Free;
 listview.Items.Count := NumberofIRCommands;
 listview.Refresh;
end;


function TFrmIrMonitor.ProcessRunning(exefile : string): boolean;
var
 PE: TProcessEntry32;
 Snap: THandle;
begin
 result := false;
 Snap:= CreateToolHelp32Snapshot(TH32CS_SNAPPROCESS, 0);
 try
  if Snap <> 0 then
  begin
  pe.dwSize := sizeof(TProcessEntry32);
   if Process32First(Snap, PE) then
   begin
   // frmmain.memo1.lines.add(lowercase(string(PE.szExeFile)));
    //frmmain.memo2.lines.add(lowercase(exefile));
    if strcomp(pchar(lowercase(string(PE.szExeFile))),pchar(lowercase(exefile))) = 0 then
    begin
     Result:= true;
    end
    else
    begin
     while Process32Next(Snap, PE) do
     begin
     // frmmain.memo1.lines.add(lowercase(string(PE.szExeFile)));
     // frmmain.memo2.lines.add(lowercase(exefile));
      if strcomp(pchar(lowercase(string(PE.szExeFile))),pchar(lowercase(exefile))) = 0  then
      begin
       Result:= true;
       break;
      end;
     end;
    end;
   end;
  end;
  finally
    CloseHandle(Snap);
  end;
end;


function TFrmIrMonitor.StartMSI:boolean;
begin
  if not started then begin
    lib := LoadLibrary('./RemtCtrl.dll');
    if lib=0 then Error('Error loading RemtCtrl.dll!'+chr(13)+'Make sure the dll files are located in the same folder as this program !');
    InitRemoteCtrl := GetProcAddress(lib,'InitRemoteCtrl');
    ReadRemoteData := GetProcAddress(lib,'ReadRemoteData');
    if (@InitRemoteCtrl=nil)or(@ReadRemoteData=nil) then Error('Dll error');
    if not InitRemoteCtrl(0) then Error('Initializing the Remote Failed!');
    started := True;
    log.lines.add('Succesfully started MSI Infra red monitoring!');
  end;
  result := True;
end;

function TFrmIrMonitor.StopMSI:boolean;
begin
  if started then begin
    started := False;
    FreeLibrary(lib);
    log.lines.add('Succesfully Stopped MSI Infra red monitoring!');
  end;
  result := True;
end;

procedure TFrmIrMonitor.Error(const msg:string);
begin
  raise Exception.Create(msg);
end;

procedure TFrmIrMonitor.TimerTimer(Sender: TObject);
var
  key:DWORD;
begin
  if not started then exit;
  key := ReadRemoteData;
  if key<>$FF then begin
    HandleIr(key);
  end;
end;


procedure TFrmIrMonitor.Sendkey(key : char);
begin
 keybd_event(ord(key),ord(key), 0, 0);
 sleep(30);
 keybd_event(ord(key), ord(key), KEYEVENTF_KEYUP, 0);
end;

procedure TFrmIrMonitor.SendAltkey(key : char);
begin
 keybd_event(18,18, 0, 0);
 keybd_event(ord(key),ord(key), 0, 0);
 sleep(30);
 keybd_event(18, 18, KEYEVENTF_KEYUP, 0);
 keybd_event(ord(key), ord(key), KEYEVENTF_KEYUP, 0);

end;

Function Create_Cstring(PascalString : String) : pchar;
    Var NewString : String; 
          Convert_To_Cstring : pchar;
    Begin 
        NewString := PascalString + Chr(0) ; 
        Convert_To_Cstring := @NewString[1] ; 
        Create_Cstring := StrNew(Convert_To_Cstring) ; 
    End; 


procedure TFrmIrMonitor.HandleIR(Key: DWORD);
var
 winhandle : HWND;
 teller : integer;
begin
 log.lines.Add('Received Infrared signal with key number : ' + intToStr(Key));
 for teller := 0 to numberofircommands-1 do
 begin
  if key = ircommands[teller].IRCode then
  begin


   case ircommands[teller].Action of
    1:begin
      //start program
      if not ProcessRunning(extractfilename(ircommands[teller].target)) then
      begin
        shellexecute(application.Handle,'open',Create_Cstring(ircommands[teller].target),nil,Create_CString(extractfilepath(ircommands[teller].target)),SW_SHOW);
        log.lines.Add('Infrared signal: ' + intToStr(Key) + ' -> Starting:' +extractfilename(ircommands[teller].target));
      end;
      end;
    2:begin
       //quit program
       winhandle := findwindow(Create_Cstring(ircommands[teller].target),nil);
       if winhandle > 0 then
       begin
        postmessage(winhandle,WM_CLOSE,0,0);
        log.lines.Add('Infrared signal: ' + intToStr(Key) + ' -> Quiting program with classname: ' +extractfilename(ircommands[teller].target));
       end;
      end;
    3:begin
       // sendkey
       winhandle := findwindow(Create_Cstring(ircommands[teller].target),nil);
       if winhandle > 0 then
       begin
        setforegroundwindow(winhandle);
        sendkey(chr(ircommands[teller].Key));
        log.lines.Add('Infrared signal: ' + intToStr(Key) + ' -> sending keyboard code ' + inttostr(ircommands[teller].Key) + ' to program with classname: ' +extractfilename(ircommands[teller].target));
       end;
      end;
    4:begin
      //send alt key
       winhandle := findwindow(Create_Cstring(ircommands[teller].target),nil);
       if winhandle > 0 then
       begin
        setforegroundwindow(winhandle);
        sendaltkey(chr(ircommands[teller].Key));
        log.lines.Add('Infrared signal: ' + intToStr(Key) + ' -> sending ALT + keyboard code ' + inttostr(ircommands[teller].Key) + ' to program with classname: ' +extractfilename(ircommands[teller].target));
       end;
      end;
   end;
  end;
 end;
end;

procedure TFrmIrMonitor.ClearIRCommands();
var
 teller : integer;
begin
for teller := 1 to 255 do
 begin
  IRCommands[teller].IRCode := -1;
  IRCommands[teller].Action := -1;
  IRCommands[teller].Key := -1;
  IRCommands[teller].target := '';
 end;
 NumberOfIRCommands := 0;
 listview.Items.Count := NumberofIRCommands;
 listview.Refresh;
end;

procedure TFrmIrMonitor.FormCreate(Sender: TObject);
begin
 loadSettings(extractfilepath(application.exename) + '\ircommands.ini');
 StartMsi();
 Timer.Enabled := true;
end;

procedure TFrmIrMonitor.FormDestroy(Sender: TObject);
begin
 SaveSettings(extractfilepath(application.exename) + '\ircommands.ini');
 StopMSI();
end;

procedure TFrmIrMonitor.ButAddCommandClick(Sender: TObject);
begin
 timer.Enabled := false;
 ErasePreviousCommand();
 FrmEditAddIrCodeAction.butAdd.Visible := true;
 FrmEditAddIrCodeAction.butedit.Visible := false;
 if FrmEditAddIrCodeAction.ShowModal = MROK then
 begin
  IRCommands[listview.Items.count  ].IRCode := strtoint(FrmEditAddIrCodeAction.edtIRCode.Text);
  if FrmEditAddIrCodeAction.radStartProgram.checked then
  begin
   IRCommands[listview.Items.count ].Action := 1;
   IRCommands[listview.Items.count ].target := FrmEditAddIrCodeAction.edtstartProgram.text;
   IRCommands[listview.Items.count ].key := -1;
  end;

  if FrmEditAddIrCodeAction.radQuitProgram.checked then
  begin
   IRCommands[listview.Items.count ].Action := 2;
   IRCommands[listview.Items.count ].target := FrmEditAddIrCodeAction.edtQuitProgram.text;
   IRCommands[listview.Items.count ].key := -1;
  end;

  if FrmEditAddIrCodeAction.RadSendKey.checked then
  begin
   IRCommands[listview.Items.count ].Action := 3;
   IRCommands[listview.Items.count ].target := FrmEditAddIrCodeAction.edtkeyProgram.text;
   IRCommands[listview.Items.count ].key :=  strtoint(FrmEditAddIrCodeAction.edtkey.text);
  end;

  if FrmEditAddIrCodeAction.RadSendAltKey.checked then
  begin
   IRCommands[listview.Items.count ].Action := 4;
   IRCommands[listview.Items.count ].target := FrmEditAddIrCodeAction.edtaltkeyProgram.text;
   IRCommands[listview.Items.count ].key := strtoint(FrmEditAddIrCodeAction.edtaltkey.text);
  end;

  inc(NumberofIRCommands);
  listview.items.Count := NumberofIrCommands;

 end;
 timer.Enabled := true;
end;

procedure TFrmIrMonitor.ListViewData(Sender: TObject; Item: TListItem);
begin
 if item.Index < NumberofIrCommands then
 begin
  item.Caption := inttostr(item.index+1);
  item.SubItems.Add(inttostr(IRCommands[item.index].IRCode));
  case IRCommands[item.Index].Action of
   1 :  begin
         item.SubItems.Add('Start Program');
         item.SubItems.Add(IRCommands[item.index].target);
        end;
   2 :  begin
         item.SubItems.Add('Quit Program');
         item.SubItems.Add(IRCommands[item.index].target);
        end;
   3 :  begin
         item.SubItems.Add('Send Key To Program');
         item.SubItems.Add(IRCommands[item.index].target);
         item.SubItems.add(inttostr(IRCommands[item.index].Key)+ ':' + chr(IRCommands[item.index].Key) );
        end;
   4 :  begin
         item.SubItems.Add('Send Alt+Key To Program');
         item.SubItems.Add(IRCommands[item.index].target);
         item.SubItems.add(inttostr(IRCommands[item.index].Key)+ ':' + chr(IRCommands[item.index].Key) );
        end;
  end;
 end;
end;

procedure TFrmIrMonitor.ErasePreviousCommand();
begin
  FrmEditAddIrCodeAction.butselectstartprogram.Enabled := false;
  FrmEditAddIrCodeAction.butselectQuitprogram.Enabled := false;
  FrmEditAddIrCodeAction.butselectkeyprogram.Enabled := false;
  FrmEditAddIrCodeAction.butselectAltkeyprogram.Enabled := false;
  FrmEditAddIrCodeAction.RadStartProgram.Checked := false;
  FrmEditAddIrCodeAction.RadQuitProgram.Checked := false;
  FrmEditAddIrCodeAction.RadSendKey.Checked := false;
  FrmEditAddIrCodeAction.RadSendAltKey.Checked := false;
  FrmEditAddIrCodeAction.EdtKey.Text := '';
  FrmEditAddIrCodeAction.EdtKeyProgram.Text := '';
  FrmEditAddIrCodeAction.EdtAltKey.Text := '';
  FrmEditAddIrCodeAction.edtAltKeyProgram.Text := '';
  FrmEditAddIrCodeAction.edtStartProgram.Text := '';
  FrmEditAddIrCodeAction.edtQuitProgram.Text := '';
  FrmEditAddIrCodeAction.edtIRCode.Text := '';
  FrmEditAddIrCodeAction.EdtKeychar.Text := '';
  FrmEditAddIrCodeAction.EdtAltKeyChar.Text := '';
end;

procedure TFrmIrMonitor.ButEditCommandClick(Sender: TObject);
begin
 if listview.SelCount > 0 then
 begin
 if (listview.Selected.Index >= 0) and (listview.Selected.index < NumberofIRCommands) then
 begin
  ErasePreviousCommand();
  FrmEditAddIrCodeAction.butAdd.Visible := false;
  FrmEditAddIrCodeAction.butedit.Visible := true;

  FrmEditAddIrCodeAction.edtIRCode.Text := inttostr(IRCommands[listview.Selected.Index].ircode);
  case IRCommands[listview.Selected.Index].Action of
   1 :  begin
         FrmEditAddIrCodeAction.RadStartProgram.Checked := true;
         FrmEditAddIrCodeAction.edtStartProgram.text := IRCommands[listview.Selected.Index].target;
        end;
   2 :  begin
         FrmEditAddIrCodeAction.RadQuitProgram.Checked := true;
         FrmEditAddIrCodeAction.edtQuitProgram.text := IRCommands[listview.Selected.Index].target;
        end;
   3 :  begin
         FrmEditAddIrCodeAction.Radsendkey.Checked := true;
         FrmEditAddIrCodeAction.edtkeyProgram.text := IRCommands[listview.Selected.Index].target;
         FrmEditAddIrCodeAction.EdtKey.text := inttostr(IRCommands[listview.Selected.Index].key);
         FrmEditAddIrCodeAction.EdtKeychar.text := chr(IRCommands[listview.Selected.Index].key);
        end;
   4 :  begin
         FrmEditAddIrCodeAction.RadsendAltkey.Checked := true;
         FrmEditAddIrCodeAction.edtaltkeyProgram.text := IRCommands[listview.Selected.Index].target;
         FrmEditAddIrCodeAction.EdtaltKey.text := inttostr(IRCommands[listview.Selected.Index].key);
         FrmEditAddIrCodeAction.EdtaltKeychar.text := chr(IRCommands[listview.Selected.Index].key);
        end;
  end;

 timer.Enabled := false;
 if FrmEditAddIrCodeAction.ShowModal = MROK then
 begin
  IRCommands[listview.Selected.Index].IRCode := strtoint(FrmEditAddIrCodeAction.edtIRCode.Text);
  if FrmEditAddIrCodeAction.radStartProgram.checked then
  begin
   IRCommands[listview.Selected.Index ].Action := 1;
   IRCommands[listview.Selected.Index ].target := FrmEditAddIrCodeAction.edtstartProgram.text;
   IRCommands[listview.Selected.Index ].key := -1;
  end;

  if FrmEditAddIrCodeAction.radQuitProgram.checked then
  begin
   IRCommands[listview.Selected.Index ].Action := 2;
   IRCommands[listview.Selected.Index ].target := FrmEditAddIrCodeAction.edtQuitProgram.text;
   IRCommands[listview.Selected.Index ].key := -1;
  end;

  if FrmEditAddIrCodeAction.RadSendKey.checked then
  begin
   IRCommands[listview.Selected.Index ].Action := 3;
   IRCommands[listview.Selected.Index ].target := FrmEditAddIrCodeAction.edtkeyProgram.text;
   IRCommands[listview.Selected.Index ].key :=  strtoint(FrmEditAddIrCodeAction.edtkey.text);
  end;

  if FrmEditAddIrCodeAction.RadSendAltKey.checked then
  begin
   IRCommands[listview.Selected.Index ].Action := 4;
   IRCommands[listview.Selected.Index ].target := FrmEditAddIrCodeAction.edtaltkeyProgram.text;
   IRCommands[listview.Selected.Index ].key := strtoint(FrmEditAddIrCodeAction.edtaltkey.text);
  end;
  listview.Refresh;
 end;
 timer.Enabled := true;
 end;
 end
 else
  application.MessageBox('Please Select an item first ','No Item Selected!',MB_OK+MB_ICONEXCLAMATION);

end;

procedure TFrmIrMonitor.ButDeleteCommandClick(Sender: TObject);
var
teller : integer;
begin
 if listview.SelCount > 0 then
 begin
  timer.Enabled := false;
  for teller := listview.Selected.Index to 254 do
  begin
   IRCommands[teller ].IRCode := IRCommands[teller +1 ].IRCode;
   IRCommands[teller ].Action := IRCommands[teller +1 ].Action;
   IRCommands[teller ].Key := IRCommands[teller +1 ].Key;
   IRCommands[teller ].target := IRCommands[teller +1 ].target ;
  end;
  IRCommands[NumberofIRCommands ].IRCode := -1;
  IRCommands[NumberofIRCommands ].Action := -1;
  IRCommands[NumberofIRCommands ].Key := -1;
  IRCommands[NumberofIRCommands ].target := '' ;

  dec(NumberofIRCommands);
  listview.Items.Count := NumberofIRCommands;
  listview.Refresh;
  timer.enabled := true;
 end
 else
  application.MessageBox('Please Select an item first ','No Item Selected!',MB_OK+MB_ICONEXCLAMATION);

end;

procedure TFrmIrMonitor.ButExportClick(Sender: TObject);
var
filename : string;
begin
 if  savedialog.Execute then
 begin
  if (extractfileext(savedialog.FileName) = '') or (extractfileext(savedialog.FileName) <> '.ir') then filename := savedialog.FileName + '.ir' else filename := savedialog.filename;
  timer.enabled := false;
  savesettings(filename);
  timer.Enabled := true;
 end;
end;

procedure TFrmIrMonitor.ButImportClick(Sender: TObject);
begin
 if opendialog.Execute then
 begin
  timer.Enabled := false;
  loadsettings(opendialog.filename);
  timer.enabled := true;
 end;
end;

procedure TFrmIrMonitor.ButClearAllClick(Sender: TObject);
begin
 if application.MessageBox('Are you sure you want to clear all commands ?','Clear all ?',MB_YESNO+MB_ICONQUESTION) = MRYES then
 begin
  timer.Enabled := false;
  ClearIrCommands();
  timer.Enabled := true;
 end;
end;

end.
